package com.example.android_example;

import android.app.Activity;
import android.os.Bundle;
import android.os.StrictMode;

import com.alibaba.sdk.android.oss.OSSService;
import com.alibaba.sdk.android.oss.OSSServiceProvider;
import com.alibaba.sdk.android.oss.model.AccessControlList;
import com.alibaba.sdk.android.oss.model.AuthenticationType;
import com.alibaba.sdk.android.oss.model.ClientConfiguration;
import com.alibaba.sdk.android.oss.model.TokenGenerator;
import com.alibaba.sdk.android.oss.util.OSSLog;
import com.alibaba.sdk.android.oss.util.OSSToolKit;

public class MainActivity extends Activity {

    static final String accessKey = "<your access key>"; // 测试代码没有考虑AK/SK的安全性
    static final String screctKey = "<your secret key>";

    public static final String srcFileDir = "<your data directory>" + "/"; // 该目录下要有两个文件：file1m  file10m

    public static final String bucketName = "<your bucket name>";

    public static OSSService ossService = OSSServiceProvider.getService();

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        OSSLog.enableLog();

        // 初始化设置
        ossService.setApplicationContext(this.getApplicationContext());
        ossService.setGlobalDefaultHostId("oss-cn-hangzhou.aliyuncs.com"); // 设置region host 即 endpoint
        ossService.setGlobalDefaultACL(AccessControlList.PRIVATE); // 默认为private
        ossService.setAuthenticationType(AuthenticationType.ORIGIN_AKSK); // 设置加签类型为原始AK/SK加签
        ossService.setGlobalDefaultTokenGenerator(new TokenGenerator() { // 设置全局默认加签器
            @Override
            public String generateToken(String httpMethod, String md5, String type, String date,
                    String ossHeaders, String resource) {

                String content = httpMethod + "\n" + md5 + "\n" + type + "\n" + date + "\n" + ossHeaders
                        + resource;

                return OSSToolKit.generateToken(accessKey, screctKey, content);
            }
        });
        ossService.setCustomStandardTimeWithEpochSec(System.currentTimeMillis() / 1000);

        ClientConfiguration conf = new ClientConfiguration();
        conf.setConnectTimeout(15 * 1000); // 设置全局网络连接超时时间，默认30s
        conf.setSocketTimeout(15 * 1000); // 设置全局socket超时时间，默认30s
        conf.setMaxConnections(50); // 设置全局最大并发网络链接数, 默认50
        ossService.setClientConfiguration(conf);

        startDemo();
    }

    public void startDemo() {

        // new Thread(new Runnable() {
        //     @Override
        //     public void run() {
        //         new ListObjectsInBucketDemo().show();
        //     }
        // }).start();

        // new Thread(new Runnable() {
        //     @Override
        //     public void run() {
        //         new GetAndUploadDataDemo().show();;
        //     }
        // }).start();


        // new Thread(new Runnable() {
        //     @Override
        //     public void run() {
        //         new GetAndUploadFileDemo().show();
        //     }
        // }).start();

        new Thread(new Runnable() {
            @Override
            public void run() {
                new MultipartUploadDemo().show();
            }
        }).start();
    }
}
