package com.aliyun.pop.demo;

import com.alibaba.dcm.DnsCacheManipulator;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.http.HttpResponse;
import com.aliyuncs.http.MethodType;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;
import com.aliyuncs.sts.model.v20150401.GetFederationTokenRequest;
import com.aliyuncs.sts.model.v20150401.GetFederationTokenResponse;

import java.nio.charset.Charset;

/**
 * @author ding.lid
 */
public class PopClientDemo {
    public static void main(String[] args) throws Exception {
        DnsCacheManipulator.loadDnsCacheConfig();

        IClientProfile profile = DefaultProfile.getProfile("cn-hangzhou", "01ysfm6c4x7j5uqbbd6c9ytu", "yViRSoJvzHF1aYBadrc0mvR5VDw=");
        DefaultAcsClient client = new DefaultAcsClient(profile);

        final String policy = "{\n" +
                "    \"Version\": \"1\", \n" +
                "    \"Statement\": [\n" +
                "        {\n" +
                "            \"Action\": [\n" +
                "                \"oss:GetBucketAcl\", \n" +
                "                \"oss:GetBucket\", \n" +
                "                \"oss:PutObject\", \n" +
                "                \"oss:GetObject\", \n" +
                "                \"oss:DeleteObject\"\n" +
                "            ], \n" +
                "            \"Resource\": [\n" +
                "                \"acs:oss:*:1775305056529849:mybucket\", \n" +
                "                \"acs:oss:*:1775305056529849:mybucket/file*\"\n" +
                "            ], \n" +
                "            \"Effect\": \"Allow\"\n" +
                "        }\n" +
                "    ]\n" +
                "}";

        final GetFederationTokenRequest request = new GetFederationTokenRequest();
        request.setVersion("2015-04-01");
        request.setMethod(MethodType.POST);

        request.setStsVersion("1");
        request.setName("grantee");
        request.setPolicy(policy);
        request.setDurationSeconds(24 * 3600L);


        final GetFederationTokenResponse response = client.getAcsResponse(request);
        System.out.printf("%s(?): %s ", response.getRequestId(), response.getFederatedUser());
        final GetFederationTokenResponse.Credentials credentials = response.getCredentials();
        System.out.printf(" %s, (%s | %s ),  %s", credentials.getExpiration(),
                credentials.getAccessKeyId(), credentials.getSecurityToken(),
                credentials.getSecurityToken());
        System.out.println();

        System.out.println("=================================================");

        final HttpResponse httpResponse = client.doAction(request);
        final String content = new String(httpResponse.getContent(), Charset.forName(httpResponse.getEncoding()));
        if (!httpResponse.isSuccess()) {
            throw new IllegalStateException("Fail to invoke GetFederationToken: " + content);
        }

        System.out.println("Success to GetFederationToken: " + content);
    }
}
