package com.aliyun.sts.impl;

import com.aliyun.sts.StsException;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

public class StsExceptionTest {
    @Test
    public void test_StsExceptionMessage() throws Exception {
        @SuppressWarnings("ThrowableInstanceNeverThrown")
        StsException exception = new StsException("head", "42", "hello", new NullPointerException("NPE"));
        assertEquals("head, code: 42, message: hello, cause: NPE", exception.getMessage());

        exception = new StsException(null, "42", "hello", new NullPointerException("NPE"));
        assertEquals("code: 42, message: hello, cause: NPE", exception.getMessage());

        exception = new StsException("head", "", "hello", new NullPointerException("NPE"));
        assertEquals("head, message: hello, cause: NPE", exception.getMessage());

        exception = new StsException("head", "", null, new NullPointerException("NPE"));
        assertEquals("head, cause: NPE", exception.getMessage());

        exception = new StsException("head", "", "hello", null);
        assertEquals("head, message: hello", exception.getMessage());
    }

    @Test
    public void test_StsExceptionToString() throws Exception {
        @SuppressWarnings("ThrowableInstanceNeverThrown")
        StsException exception = new StsException("head", "42", "hello", new NullPointerException("NPE"));
        assertEquals(exception.getClass().getName() + ": " + "head, code: 42, message: hello, cause: NPE",
                exception.toString());
    }
}
