package com.aliyun.oss.demo;

import com.alibaba.dcm.DnsCacheManipulator;
import com.aliyun.oss.OSSClient;
import com.aliyun.oss.model.Bucket;
import com.aliyun.oss.model.OSSObject;
import com.aliyun.oss.model.ObjectMetadata;
import org.apache.commons.io.IOUtils;

import java.io.ByteArrayInputStream;
import java.util.List;

import static org.junit.Assert.assertArrayEquals;

/**
 * @author ding.lid
 */
public class OssClient4TestEnvDemo {
    public static final String ENDPOINT = "http://oss-test.aliyun-inc.com:8092";
    public static final String ACCESS_KEY_ID = "XUWvYXzPxA8xoZWd";
    public static final String ACCESS_KEY_SECRET = "8u6cKsQNlJZUIfX9BfB01HKWnUG2dn";

    static final String BUCKET_NAME = "hey42";
    static final String PATH = "sts-test/hello.txt";

    public static void main(String[] args) throws Exception {
        DnsCacheManipulator.loadDnsCacheConfig();

        OSSClient client = null;
        try {
            client = new OSSClient(ENDPOINT, ACCESS_KEY_ID, ACCESS_KEY_SECRET);

//            final CreateBucketRequest createBucketRequest = new CreateBucketRequest("hey42");
//            client.createBucket(createBucketRequest);

            final List<Bucket> buckets = client.listBuckets();
            for (Bucket bucket : buckets) {
                final String name = bucket.getName();
                System.out.println(name);
            }

            String text = "中华人民共和国。Hello!";
            byte[] content = text.getBytes("UTF-8");

            ObjectMetadata meta = new ObjectMetadata();
            meta.setContentLength(content.length);

            client.putObject(BUCKET_NAME, PATH, new ByteArrayInputStream(content), meta);

            OSSObject object = client.getObject(BUCKET_NAME, PATH);
            byte[] bytes = IOUtils.toByteArray(object.getObjectContent());

            assertArrayEquals(content, bytes);
            System.out.println("Success");
        } finally {
            if (null != client) {
//                client.deleteObject(BUCKET_NAME, PATH);
            }
        }
    }
}
