package com.aliyun.oss.demo;

import com.aliyun.oss.OSSClient;
import com.aliyun.oss.model.OSSObject;
import com.aliyun.oss.model.ObjectMetadata;
import org.apache.commons.io.IOUtils;

import java.io.ByteArrayInputStream;

import static org.junit.Assert.assertArrayEquals;

/**
 * @author ding.lid
 */
public class OssClientDemo {
    static final String ENDPOINT = "http://oss-cn-hangzhou.aliyuncs.com";
    static final String ACCESS_KEY_ID = "39VkvH8Wk9D9HjNU";
    static final String ACCESS_KEY_SECRET = "po4PElGOHWysWHxVoC2u37wDdOVl9S";

    static final String BUCKET_NAME = "sts-ut";
    static final String PATH = "sts-test/hello.txt";

    public static void main(String[] args) throws Exception {
        OSSClient client = null;
        try {
            client = new OSSClient(ENDPOINT, ACCESS_KEY_ID, ACCESS_KEY_SECRET);
            String text = "中华人民共和国。Hello!";
            byte[] content = text.getBytes("UTF-8");

            ObjectMetadata meta = new ObjectMetadata();
            meta.setContentLength(content.length);

            client.putObject(BUCKET_NAME, PATH, new ByteArrayInputStream(content), meta);

            OSSObject object = client.getObject(BUCKET_NAME, PATH);
            byte[] bytes = IOUtils.toByteArray(object.getObjectContent());

            assertArrayEquals(content, bytes);
            System.out.println("Success");
        } finally {
            if (null != client) {
                client.deleteObject(BUCKET_NAME, PATH);
            }
        }
    }
}
